<?php
/**
 * User: dimka3210
 * Date: 22.11.13
 * Time: 14:11
 */
if (!defined('BB_ROOT')) die(basename(__FILE__));
require(BB_ROOT . 'common.php');
require(INC_DIR . 'bbcode.php');
require(INC_DIR . 'functions_post.php');

$user->session_start();

class NewsGrab
{
    private $URL = 'http://www.3dnews.ru';

    public function run()
    {
        global $userdata;
        $bot = DB()->fetch_row('SELECT * FROM bb_users WHERE user_id ="' . BOT_UID . '"');
        $userdata = $bot;

        $html = $this->_getHtml('http://www.3dnews.ru/news');
        $html .= $this->_getHtml('http://www.3dnews.ru/software-news'); //Впиши сюда сылку
        $links = $this->_parseLinksTheme($html);
        array_walk($links, function (&$item) {
            $item = 'http://www.3dnews.ru/' . $item;
        });

        $err = array();
				
        foreach ($links as $link) {
            $html = $this->_getHtml($link);
            $data = $this->_parseInnerPage($html);
            $err[] = $this->_saveRow($data);
            sleep(1);
        }

        return $err;
    }

    /**
     * @param $link
     * @return string
     */
    private function _getHtml($link)
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $link);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_BINARYTRANSFER, true);
        $html = curl_exec($ch);
        curl_close($ch);

        return $html;
    }

    /**
     * @param $html
     * @return array
     */
    private function _parseLinksTheme($html)
    {
        $pattern = '<a class="entry-header" href="/(\d+)"><h1>.*</h1></a>';
        preg_match_all("~$pattern~U", $html, $matches);
        if (count($matches[1]))
            return $matches[1];
        else
            return array();
    }

    private function _parseInnerPage($html)
    {
        $result = array();

        preg_match('~<div\sclass="entry-body _ga1_on_" itemprop="articleBody">(.*)<p><strong>Материалы\sпо\sтеме~s', $html, $match);
        if (isset($match[1])) {
            $result['text'] = $match[1];
        } else {
            $result['text'] = '';
        }

        preg_match('~<h1 itemprop="name">(.*)</h1></div>~', $html, $match);
        if (isset($match[1])) {
            $result['title'] = $match[1];
        } else {
            $result['title'] = '';
        }

        preg_match('~<a name="(\d+)"></a>~', $html, $match);
        if (isset($match[1])) {
            $result['id'] = $match[1];
        } else {
            $result['id'] = '';
        }

        return $result;
    }

    private function _saveRow($data)
    {
	//echo '<hr>';
	//print_r($data);
	
	
        global $bb_cfg;

		if(!$data['id'])
			return false;
		
        if (DB()->fetch_row("SELECT * FROM bb_news_grab WHERE import_id = " . $data['id'])) {
            return false;
        }

        $import_sql = 'INSERT INTO bb_news_grab (import_id) VALUES ('.$data['id'].')';
        DB()->sql_query($import_sql);

        $topic_sql = "INSERT INTO bb_topics (topic_title, topic_poster, topic_time, forum_id, topic_status, topic_type, topic_dl_type, topic_vote, is_draft, topic_last_post_time) VALUES ('" . $data['title'] . "', " . BOT_UID . ", " . time() . ", " . $bb_cfg['network_news_forum_id'] . ", 0, 0, 0, 0, 0," . time() . ")";
        DB()->sql_query($topic_sql);
        $topic_id = DB()->fetch_row('SELECT LAST_INSERT_ID() as last');
        $topic_id = $topic_id['last'];

        $post_sql = "INSERT INTO bb_posts (topic_id, forum_id, poster_id, post_username, post_time, poster_ip) VALUES (" . $topic_id . ", " . $bb_cfg['network_news_forum_id'] . ", " . BOT_UID . ", 'Bot', " . time() . ", '127.0.0.1')";
        DB()->sql_query($post_sql);
        $post_id = DB()->fetch_row('SELECT LAST_INSERT_ID() as last');
        $post_id = $post_id['last'];

        $post_text_sql = "INSERT INTO bb_posts_text (post_id, post_text) VALUES (" . $post_id . ", '" . DB()->escape($data['text']) . "')";
        DB()->sql_query($post_text_sql);

    }
} 